/* key-manager-store.c generated by valac 0.44.7, the Vala compiler
 * generated from key-manager-store.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2003 Jacob Perkins
 * Copyright (C) 2004, 2005, 2006 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2018 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include <ui/gcr-ui.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gcr/gcr-base.h>
#include <pango/pango.h>
#include "libegg/eggtreemultidnd.h"
#include <glib/gi18n-lib.h>

#define SEAHORSE_TYPE_KEY_MANAGER_STORE (seahorse_key_manager_store_get_type ())
#define SEAHORSE_KEY_MANAGER_STORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_TYPE_KEY_MANAGER_STORE, SeahorseKeyManagerStore))
#define SEAHORSE_KEY_MANAGER_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_TYPE_KEY_MANAGER_STORE, SeahorseKeyManagerStoreClass))
#define SEAHORSE_IS_KEY_MANAGER_STORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_TYPE_KEY_MANAGER_STORE))
#define SEAHORSE_IS_KEY_MANAGER_STORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_TYPE_KEY_MANAGER_STORE))
#define SEAHORSE_KEY_MANAGER_STORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_TYPE_KEY_MANAGER_STORE, SeahorseKeyManagerStoreClass))

typedef struct _SeahorseKeyManagerStore SeahorseKeyManagerStore;
typedef struct _SeahorseKeyManagerStoreClass SeahorseKeyManagerStoreClass;
typedef struct _SeahorseKeyManagerStorePrivate SeahorseKeyManagerStorePrivate;
typedef enum  {
	SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_ANY,
	SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_PERSONAL,
	SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_TRUSTED
} SeahorseKeyManagerStoreShowFilter;

#define SEAHORSE_KEY_MANAGER_STORE_TYPE_SHOW_FILTER (seahorse_key_manager_store_show_filter_get_type ())
enum  {
	SEAHORSE_KEY_MANAGER_STORE_0_PROPERTY,
	SEAHORSE_KEY_MANAGER_STORE_SETTINGS_PROPERTY,
	SEAHORSE_KEY_MANAGER_STORE_FILTER_PROPERTY,
	SEAHORSE_KEY_MANAGER_STORE_SHOWFILTER_PROPERTY,
	SEAHORSE_KEY_MANAGER_STORE_NUM_PROPERTIES
};
static GParamSpec* seahorse_key_manager_store_properties[SEAHORSE_KEY_MANAGER_STORE_NUM_PROPERTIES];
typedef enum  {
	SEAHORSE_KEY_MANAGER_STORE_DRAG_INFO_TEXT,
	SEAHORSE_KEY_MANAGER_STORE_DRAG_INFO_XDS
} SeahorseKeyManagerStoreDragInfo;

#define SEAHORSE_KEY_MANAGER_STORE_TYPE_DRAG_INFO (seahorse_key_manager_store_drag_info_get_type ())
typedef enum  {
	SEAHORSE_KEY_MANAGER_STORE_COLUMN_ICON,
	SEAHORSE_KEY_MANAGER_STORE_COLUMN_MARKUP,
	SEAHORSE_KEY_MANAGER_STORE_COLUMN_LABEL,
	SEAHORSE_KEY_MANAGER_STORE_COLUMN_DESCRIPTION,
	SEAHORSE_KEY_MANAGER_STORE_COLUMN_N_COLS
} SeahorseKeyManagerStoreColumn;

#define SEAHORSE_KEY_MANAGER_STORE_TYPE_COLUMN (seahorse_key_manager_store_column_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	SEAHORSE_FLAG_NONE = 0,
	SEAHORSE_FLAG_IS_VALID = 0x00000001,
	SEAHORSE_FLAG_CAN_ENCRYPT = 0x00000002,
	SEAHORSE_FLAG_CAN_SIGN = 0x00000004,
	SEAHORSE_FLAG_CAN_CERTIFY = 0x00000008,
	SEAHORSE_FLAG_CAN_AUTHENTICATE = 0x00000010,
	SEAHORSE_FLAG_EXPIRED = 0x00000100,
	SEAHORSE_FLAG_REVOKED = 0x00000200,
	SEAHORSE_FLAG_DISABLED = 0x00000400,
	SEAHORSE_FLAG_TRUSTED = 0x00001000,
	SEAHORSE_FLAG_PERSONAL = 0x00002000,
	SEAHORSE_FLAG_EXPORTABLE = 0x00100000,
	SEAHORSE_FLAG_DELETABLE = 0x10000000
} SeahorseFlags;

#define SEAHORSE_TYPE_FLAGS (seahorse_flags_get_type ())
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))

struct _SeahorseKeyManagerStore {
	GcrCollectionModel parent_instance;
	SeahorseKeyManagerStorePrivate * priv;
};

struct _SeahorseKeyManagerStoreClass {
	GcrCollectionModelClass parent_class;
};

struct _SeahorseKeyManagerStorePrivate {
	gchar* drag_destination;
	GError* drag_error;
	GList* drag_objects;
	GSettings* _settings;
	gchar* _filter;
	SeahorseKeyManagerStoreShowFilter _showfilter;
};

static gint SeahorseKeyManagerStore_private_offset;
static gpointer seahorse_key_manager_store_parent_class = NULL;
static GdkAtom seahorse_key_manager_store_XDS_ATOM;
static GdkAtom seahorse_key_manager_store_XDS_ATOM = 0U;
static GdkAtom seahorse_key_manager_store_TEXT_ATOM;
static GdkAtom seahorse_key_manager_store_TEXT_ATOM = 0U;
static GcrColumn* seahorse_key_manager_store__columns;
static gint seahorse_key_manager_store__columns_length1;
static GcrColumn* seahorse_key_manager_store__columns = NULL;
static gint seahorse_key_manager_store__columns_length1 = 0;
static gint _seahorse_key_manager_store__columns_size_ = 0;

GType seahorse_key_manager_store_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SeahorseKeyManagerStore, g_object_unref)
GType seahorse_key_manager_store_show_filter_get_type (void) G_GNUC_CONST;
static void seahorse_key_manager_store_on_sort_column_changed (SeahorseKeyManagerStore* self,
                                                        GtkTreeSortable* sort);
const gchar* seahorse_key_manager_store_show_filter_to_string (SeahorseKeyManagerStoreShowFilter self);
SeahorseKeyManagerStoreShowFilter seahorse_key_manager_store_show_filter_from_string (const gchar* str);
static GType seahorse_key_manager_store_drag_info_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static GType seahorse_key_manager_store_column_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
#define SEAHORSE_KEY_MANAGER_STORE_XDS_FILENAME "xds.txt"
#define SEAHORSE_KEY_MANAGER_STORE_MAX_XDS_ATOM_VAL_LEN ((gsize) 4096)
SeahorseKeyManagerStore* seahorse_key_manager_store_new (GcrCollection* collection,
                                                         GtkTreeView* view,
                                                         GSettings* settings);
SeahorseKeyManagerStore* seahorse_key_manager_store_construct (GType object_type,
                                                               GcrCollection* collection,
                                                               GtkTreeView* view,
                                                               GSettings* settings);
static gboolean seahorse_key_manager_store_on_filter_visible (SeahorseKeyManagerStore* self,
                                                       GObject* obj);
static gboolean _seahorse_key_manager_store_on_filter_visible_gcr_filter_collection_func (GObject* object,
                                                                                   gpointer self);
void seahorse_key_manager_store_set_settings (SeahorseKeyManagerStore* self,
                                              GSettings* value);
static void _seahorse_key_manager_store_on_sort_column_changed_gtk_tree_sortable_sort_column_changed (GtkTreeSortable* _sender,
                                                                                               gpointer self);
static void seahorse_key_manager_store_set_sort_to (SeahorseKeyManagerStore* self,
                                             const gchar* name);
static void seahorse_key_manager_store_drag_data_get (SeahorseKeyManagerStore* self,
                                               GtkWidget* widget,
                                               GdkDragContext* context,
                                               GtkSelectionData* selection_data,
                                               guint info,
                                               guint time);
static void _seahorse_key_manager_store_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                         GdkDragContext* context,
                                                                         GtkSelectionData* selection_data,
                                                                         guint info,
                                                                         guint time_,
                                                                         gpointer self);
static void seahorse_key_manager_store_drag_begin (SeahorseKeyManagerStore* self,
                                            GtkWidget* widget,
                                            GdkDragContext* context);
static void _seahorse_key_manager_store_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                                   GdkDragContext* context,
                                                                   gpointer self);
static void seahorse_key_manager_store_drag_end (SeahorseKeyManagerStore* self,
                                          GtkWidget* widget,
                                          GdkDragContext* context);
static void _seahorse_key_manager_store_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                               GdkDragContext* context,
                                                               gpointer self);
static gboolean seahorse_key_manager_store_object_contains_filtered_text (SeahorseKeyManagerStore* self,
                                                                   GObject* object,
                                                                   const gchar* text);
static gboolean seahorse_key_manager_store_apply_showfilter (SeahorseKeyManagerStore* self,
                                                      GObject* obj);
GType seahorse_flags_get_type (void) G_GNUC_CONST;
SeahorseKeyManagerStoreShowFilter seahorse_key_manager_store_get_showfilter (SeahorseKeyManagerStore* self);
const gchar* seahorse_key_manager_store_get_filter (SeahorseKeyManagerStore* self);
void seahorse_key_manager_store_refilter (SeahorseKeyManagerStore* self);
GSettings* seahorse_key_manager_store_get_settings (SeahorseKeyManagerStore* self);
static gchar* seahorse_key_manager_store_xds_get_atom_value (SeahorseKeyManagerStore* self,
                                                      GdkDragContext* context);
static gboolean seahorse_key_manager_store_xds_context_offers_target (SeahorseKeyManagerStore* self,
                                                               GdkDragContext* context,
                                                               GdkAtom target);
static gboolean seahorse_key_manager_store_xds_is_dnd_valid_context (SeahorseKeyManagerStore* self,
                                                              GdkDragContext* context);
GList* seahorse_key_manager_store_get_selected_objects (GtkTreeView* view);
static gboolean seahorse_key_manager_store_export_to_text (SeahorseKeyManagerStore* self,
                                                    GtkSelectionData* selection_data);
guint seahorse_exportable_export_to_text_wait (GList* objects,
                                               guint8** output,
                                               size_t* output_length1,
                                               GError** error);
static gboolean seahorse_key_manager_store_export_to_directory (SeahorseKeyManagerStore* self,
                                                         const gchar* directory);
gint seahorse_exportable_export_to_directory_wait (GList* objects,
                                                   const gchar* directory,
                                                   GError** error);
void seahorse_util_show_error (GtkWidget* parent,
                               const gchar* heading,
                               const gchar* message);
GObject* seahorse_key_manager_store_get_object_from_path (GtkTreeView* view,
                                                          GtkTreePath* path);
static GtkTreeIter* _gtk_tree_iter_dup (GtkTreeIter* self);
GList* seahorse_key_manager_store_get_all_objects (SeahorseKeyManagerStore* self);
static GtkTreePath* _vala_GtkTreePath_copy (GtkTreePath* self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static gint __lambda15_ (GObject* a,
                  GObject* b);
static gint ___lambda15__gcompare_func (gconstpointer a,
                                 gconstpointer b);
static void __vala_GtkTreePath_free0_ (gpointer var);
static inline void _g_list_free___vala_GtkTreePath_free0_ (GList* self);
void seahorse_key_manager_store_set_selected_objects (GtkTreeView* view,
                                                      GList* objects);
GObject* seahorse_key_manager_store_get_selected_object (SeahorseKeyManagerStore* self,
                                                         GtkTreeView* view);
void seahorse_key_manager_store_set_filter (SeahorseKeyManagerStore* self,
                                            const gchar* value);
void seahorse_key_manager_store_set_showfilter (SeahorseKeyManagerStore* self,
                                                SeahorseKeyManagerStoreShowFilter value);
static GObject * seahorse_key_manager_store_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
static void seahorse_key_manager_store_finalize (GObject * obj);
static void _vala_seahorse_key_manager_store_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_seahorse_key_manager_store_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);

static const GtkTargetEntry SEAHORSE_KEY_MANAGER_STORE_store_targets[2] = {{"text/plain", (guint) 0, (guint) SEAHORSE_KEY_MANAGER_STORE_DRAG_INFO_TEXT}, {"XdndDirectSave0", (guint) 0, (guint) SEAHORSE_KEY_MANAGER_STORE_DRAG_INFO_XDS}};

static inline gpointer
seahorse_key_manager_store_get_instance_private (SeahorseKeyManagerStore* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseKeyManagerStore_private_offset);
}

const gchar*
seahorse_key_manager_store_show_filter_to_string (SeahorseKeyManagerStoreShowFilter self)
{
	const gchar* result = NULL;
	switch (self) {
		case SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_ANY:
		{
			result = "";
			return result;
		}
		case SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_PERSONAL:
		{
			result = "personal";
			return result;
		}
		case SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_TRUSTED:
		{
			result = "trusted";
			return result;
		}
		default:
		{
			g_assert_not_reached ();
		}
	}
}

SeahorseKeyManagerStoreShowFilter
seahorse_key_manager_store_show_filter_from_string (const gchar* str)
{
	SeahorseKeyManagerStoreShowFilter result = 0;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	static GQuark _tmp1_label2 = 0;
	static GQuark _tmp1_label3 = 0;
	static GQuark _tmp1_label4 = 0;
	_tmp0_ = str;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (((_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string (NULL)))) || (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string (""))))) || (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("any"))))) {
		switch (0) {
			default:
			{
				result = SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_ANY;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("personal")))) {
		switch (0) {
			default:
			{
				result = SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_PERSONAL;
				return result;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("trusted")))) {
		switch (0) {
			default:
			{
				result = SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_TRUSTED;
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				g_critical ("key-manager-store.vala:59: Got unknown ShowFilter string: %s", str);
				g_assert_not_reached ();
			}
		}
	}
}

GType
seahorse_key_manager_store_show_filter_get_type (void)
{
	static volatile gsize seahorse_key_manager_store_show_filter_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_key_manager_store_show_filter_type_id__volatile)) {
		static const GEnumValue values[] = {{SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_ANY, "SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_ANY", "any"}, {SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_PERSONAL, "SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_PERSONAL", "personal"}, {SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_TRUSTED, "SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_TRUSTED", "trusted"}, {0, NULL, NULL}};
		GType seahorse_key_manager_store_show_filter_type_id;
		seahorse_key_manager_store_show_filter_type_id = g_enum_register_static ("SeahorseKeyManagerStoreShowFilter", values);
		g_once_init_leave (&seahorse_key_manager_store_show_filter_type_id__volatile, seahorse_key_manager_store_show_filter_type_id);
	}
	return seahorse_key_manager_store_show_filter_type_id__volatile;
}

static GType
seahorse_key_manager_store_drag_info_get_type (void)
{
	static volatile gsize seahorse_key_manager_store_drag_info_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_key_manager_store_drag_info_type_id__volatile)) {
		static const GEnumValue values[] = {{SEAHORSE_KEY_MANAGER_STORE_DRAG_INFO_TEXT, "SEAHORSE_KEY_MANAGER_STORE_DRAG_INFO_TEXT", "text"}, {SEAHORSE_KEY_MANAGER_STORE_DRAG_INFO_XDS, "SEAHORSE_KEY_MANAGER_STORE_DRAG_INFO_XDS", "xds"}, {0, NULL, NULL}};
		GType seahorse_key_manager_store_drag_info_type_id;
		seahorse_key_manager_store_drag_info_type_id = g_enum_register_static ("SeahorseKeyManagerStoreDragInfo", values);
		g_once_init_leave (&seahorse_key_manager_store_drag_info_type_id__volatile, seahorse_key_manager_store_drag_info_type_id);
	}
	return seahorse_key_manager_store_drag_info_type_id__volatile;
}

static GType
seahorse_key_manager_store_column_get_type (void)
{
	static volatile gsize seahorse_key_manager_store_column_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_key_manager_store_column_type_id__volatile)) {
		static const GEnumValue values[] = {{SEAHORSE_KEY_MANAGER_STORE_COLUMN_ICON, "SEAHORSE_KEY_MANAGER_STORE_COLUMN_ICON", "icon"}, {SEAHORSE_KEY_MANAGER_STORE_COLUMN_MARKUP, "SEAHORSE_KEY_MANAGER_STORE_COLUMN_MARKUP", "markup"}, {SEAHORSE_KEY_MANAGER_STORE_COLUMN_LABEL, "SEAHORSE_KEY_MANAGER_STORE_COLUMN_LABEL", "label"}, {SEAHORSE_KEY_MANAGER_STORE_COLUMN_DESCRIPTION, "SEAHORSE_KEY_MANAGER_STORE_COLUMN_DESCRIPTION", "description"}, {SEAHORSE_KEY_MANAGER_STORE_COLUMN_N_COLS, "SEAHORSE_KEY_MANAGER_STORE_COLUMN_N_COLS", "n-cols"}, {0, NULL, NULL}};
		GType seahorse_key_manager_store_column_type_id;
		seahorse_key_manager_store_column_type_id = g_enum_register_static ("SeahorseKeyManagerStoreColumn", values);
		g_once_init_leave (&seahorse_key_manager_store_column_type_id__volatile, seahorse_key_manager_store_column_type_id);
	}
	return seahorse_key_manager_store_column_type_id__volatile;
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static gboolean
_seahorse_key_manager_store_on_filter_visible_gcr_filter_collection_func (GObject* object,
                                                                          gpointer self)
{
	gboolean result;
	result = seahorse_key_manager_store_on_filter_visible ((SeahorseKeyManagerStore*) self, object);
	return result;
}

static void
_seahorse_key_manager_store_on_sort_column_changed_gtk_tree_sortable_sort_column_changed (GtkTreeSortable* _sender,
                                                                                          gpointer self)
{
	seahorse_key_manager_store_on_sort_column_changed ((SeahorseKeyManagerStore*) self, _sender);
}

static void
_seahorse_key_manager_store_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                    GdkDragContext* context,
                                                                    GtkSelectionData* selection_data,
                                                                    guint info,
                                                                    guint time_,
                                                                    gpointer self)
{
	seahorse_key_manager_store_drag_data_get ((SeahorseKeyManagerStore*) self, _sender, context, selection_data, info, time_);
}

static void
_seahorse_key_manager_store_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                              GdkDragContext* context,
                                                              gpointer self)
{
	seahorse_key_manager_store_drag_begin ((SeahorseKeyManagerStore*) self, _sender, context);
}

static void
_seahorse_key_manager_store_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                          GdkDragContext* context,
                                                          gpointer self)
{
	seahorse_key_manager_store_drag_end ((SeahorseKeyManagerStore*) self, _sender, context);
}

SeahorseKeyManagerStore*
seahorse_key_manager_store_construct (GType object_type,
                                      GcrCollection* collection,
                                      GtkTreeView* view,
                                      GSettings* settings)
{
	SeahorseKeyManagerStore * self = NULL;
	GcrFilterCollection* _tmp0_;
	GcrFilterCollection* _tmp1_;
	GtkCellRendererPixbuf* icon_renderer = NULL;
	GtkCellRendererPixbuf* _tmp2_;
	GtkCellRendererPixbuf* _tmp3_;
	GtkCellRendererPixbuf* _tmp4_;
	GtkCellRendererPixbuf* _tmp5_;
	GtkCellRendererPixbuf* _tmp6_;
	GtkTreeViewColumn* col = NULL;
	GtkCellRendererPixbuf* _tmp7_;
	GtkTreeViewColumn* _tmp8_;
	GtkTreeViewColumn* _tmp9_;
	GtkTreeViewColumn* _tmp10_;
	GtkTreeViewColumn* _tmp11_;
	GtkCellRendererText* text_renderer = NULL;
	GtkCellRendererText* _tmp12_;
	GtkCellRendererText* _tmp13_;
	GtkCellRendererText* _tmp14_;
	GtkCellRendererText* _tmp15_;
	GtkCellRendererText* _tmp16_;
	GtkTreeViewColumn* _tmp17_;
	GtkCellRendererText* _tmp18_;
	GtkTreeViewColumn* _tmp19_;
	GtkCellRendererText* _tmp20_;
	GtkCellRendererText* _tmp21_;
	GtkCellRendererText* _tmp22_;
	GtkCellRendererText* _tmp23_;
	GtkCellRendererText* _tmp24_;
	GtkCellRendererText* _tmp25_;
	GtkCellRendererText* _tmp26_;
	GtkCellRendererText* _tmp27_;
	GtkTreeViewColumn* _tmp28_;
	GtkCellRendererText* _tmp29_;
	GtkTreeViewColumn* _tmp30_;
	GtkCellRendererText* _tmp31_;
	GtkTreeViewColumn* _tmp32_;
	GtkTreeViewColumn* _tmp33_;
	GtkTreeViewColumn* _tmp34_;
	gchar* sort_by = NULL;
	gchar* _tmp35_;
	const gchar* _tmp36_;
	g_return_val_if_fail (settings != NULL, NULL);
	self = (SeahorseKeyManagerStore*) g_object_new (object_type, NULL);
	_tmp0_ = (GcrFilterCollection*) gcr_filter_collection_new_with_callback (collection, _seahorse_key_manager_store_on_filter_visible_gcr_filter_collection_func, g_object_ref (self), g_object_unref);
	_tmp1_ = _tmp0_;
	gcr_collection_model_set_collection ((GcrCollectionModel*) self, (GcrCollection*) _tmp1_);
	_g_object_unref0 (_tmp1_);
	seahorse_key_manager_store_set_settings (self, settings);
	gtk_tree_view_set_model (view, (GtkTreeModel*) self);
	_tmp2_ = (GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ();
	g_object_ref_sink (_tmp2_);
	icon_renderer = _tmp2_;
	_tmp3_ = icon_renderer;
	g_object_set (_tmp3_, "stock-size", (guint) GTK_ICON_SIZE_DND, NULL);
	_tmp4_ = icon_renderer;
	g_object_set ((GtkCellRenderer*) _tmp4_, "ypad", (guint) 12, NULL);
	_tmp5_ = icon_renderer;
	g_object_set ((GtkCellRenderer*) _tmp5_, "xpad", (guint) 12, NULL);
	_tmp6_ = icon_renderer;
	g_object_set ((GtkCellRenderer*) _tmp6_, "yalign", 0.0f, NULL);
	_tmp7_ = icon_renderer;
	_tmp8_ = gtk_tree_view_column_new_with_attributes ("", (GtkCellRenderer*) _tmp7_, "gicon", SEAHORSE_KEY_MANAGER_STORE_COLUMN_ICON, NULL, NULL);
	g_object_ref_sink (_tmp8_);
	col = _tmp8_;
	_tmp9_ = col;
	gtk_tree_view_column_set_resizable (_tmp9_, FALSE);
	_tmp10_ = col;
	gtk_tree_view_append_column (view, _tmp10_);
	_tmp11_ = gtk_tree_view_column_new ();
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (col);
	col = _tmp11_;
	_tmp12_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp12_);
	text_renderer = _tmp12_;
	_tmp13_ = text_renderer;
	g_object_set ((GtkCellRenderer*) _tmp13_, "ypad", (guint) 12, NULL);
	_tmp14_ = text_renderer;
	g_object_set ((GtkCellRenderer*) _tmp14_, "yalign", 0.0f, NULL);
	_tmp15_ = text_renderer;
	g_object_set (_tmp15_, "width-chars", 30, NULL);
	_tmp16_ = text_renderer;
	g_object_set (_tmp16_, "ellipsize", PANGO_ELLIPSIZE_END, NULL);
	_tmp17_ = col;
	_tmp18_ = text_renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp17_, (GtkCellRenderer*) _tmp18_, TRUE);
	_tmp19_ = col;
	_tmp20_ = text_renderer;
	gtk_tree_view_column_set_attributes (_tmp19_, (GtkCellRenderer*) _tmp20_, "markup", SEAHORSE_KEY_MANAGER_STORE_COLUMN_MARKUP, NULL, NULL);
	_tmp21_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp21_);
	_g_object_unref0 (text_renderer);
	text_renderer = _tmp21_;
	_tmp22_ = text_renderer;
	g_object_set ((GtkCellRenderer*) _tmp22_, "ypad", (guint) 12, NULL);
	_tmp23_ = text_renderer;
	g_object_set ((GtkCellRenderer*) _tmp23_, "xpad", (guint) 12, NULL);
	_tmp24_ = text_renderer;
	g_object_set ((GtkCellRenderer*) _tmp24_, "yalign", 0.0f, NULL);
	_tmp25_ = text_renderer;
	g_object_set ((GtkCellRenderer*) _tmp25_, "xalign", 1.0f, NULL);
	_tmp26_ = text_renderer;
	g_object_set (_tmp26_, "scale", PANGO_SCALE_SMALL, NULL);
	_tmp27_ = text_renderer;
	g_object_set (_tmp27_, "alignment", PANGO_ALIGN_RIGHT, NULL);
	_tmp28_ = col;
	_tmp29_ = text_renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp28_, (GtkCellRenderer*) _tmp29_, FALSE);
	_tmp30_ = col;
	_tmp31_ = text_renderer;
	gtk_tree_view_column_set_attributes (_tmp30_, (GtkCellRenderer*) _tmp31_, "markup", SEAHORSE_KEY_MANAGER_STORE_COLUMN_DESCRIPTION, NULL, NULL);
	_tmp32_ = col;
	gtk_tree_view_column_set_resizable (_tmp32_, TRUE);
	_tmp33_ = col;
	gtk_tree_view_append_column (view, _tmp33_);
	_tmp34_ = col;
	gtk_tree_view_column_set_sort_column_id (_tmp34_, (gint) SEAHORSE_KEY_MANAGER_STORE_COLUMN_LABEL);
	g_signal_connect_object ((GtkTreeSortable*) self, "sort-column-changed", (GCallback) _seahorse_key_manager_store_on_sort_column_changed_gtk_tree_sortable_sort_column_changed, self, 0);
	_tmp35_ = g_settings_get_string (settings, "sort-by");
	sort_by = _tmp35_;
	_tmp36_ = sort_by;
	if (_tmp36_ != NULL) {
		const gchar* _tmp37_;
		_tmp37_ = sort_by;
		seahorse_key_manager_store_set_sort_to (self, _tmp37_);
	}
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) self, (gint) SEAHORSE_KEY_MANAGER_STORE_COLUMN_LABEL, GTK_SORT_ASCENDING);
	egg_tree_multi_drag_add_drag_support (view);
	g_signal_connect_object ((GtkWidget*) view, "drag-data-get", (GCallback) _seahorse_key_manager_store_drag_data_get_gtk_widget_drag_data_get, self, 0);
	g_signal_connect_object ((GtkWidget*) view, "drag-begin", (GCallback) _seahorse_key_manager_store_drag_begin_gtk_widget_drag_begin, self, 0);
	g_signal_connect_object ((GtkWidget*) view, "drag-end", (GCallback) _seahorse_key_manager_store_drag_end_gtk_widget_drag_end, self, 0);
	gtk_drag_source_set ((GtkWidget*) view, GDK_BUTTON1_MASK, SEAHORSE_KEY_MANAGER_STORE_store_targets, (gint) G_N_ELEMENTS (SEAHORSE_KEY_MANAGER_STORE_store_targets), GDK_ACTION_COPY);
	_g_free0 (sort_by);
	_g_object_unref0 (text_renderer);
	_g_object_unref0 (col);
	_g_object_unref0 (icon_renderer);
	return self;
}

SeahorseKeyManagerStore*
seahorse_key_manager_store_new (GcrCollection* collection,
                                GtkTreeView* view,
                                GSettings* settings)
{
	return seahorse_key_manager_store_construct (SEAHORSE_TYPE_KEY_MANAGER_STORE, collection, view, settings);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gboolean
seahorse_key_manager_store_object_contains_filtered_text (SeahorseKeyManagerStore* self,
                                                          GObject* object,
                                                          const gchar* text)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gchar* name = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	GObjectClass* _tmp7_;
	GParamSpec* _tmp8_;
	g_return_val_if_fail (self != NULL, FALSE);
	if (text == NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (text, "") == 0;
	}
	if (_tmp0_) {
		result = TRUE;
		return result;
	}
	name = NULL;
	g_object_get (object, "label", &_tmp1_, NULL, NULL);
	_g_free0 (name);
	name = _tmp1_;
	_tmp3_ = name;
	if (_tmp3_ != NULL) {
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp4_ = name;
		_tmp5_ = g_utf8_strdown (_tmp4_, (gssize) -1);
		_tmp6_ = _tmp5_;
		_tmp2_ = string_contains (_tmp6_, text);
		_g_free0 (_tmp6_);
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		result = TRUE;
		_g_free0 (name);
		return result;
	}
	_tmp7_ = G_OBJECT_GET_CLASS (object);
	_tmp8_ = g_object_class_find_property (_tmp7_, "description");
	if (_tmp8_ != NULL) {
		gchar* description = NULL;
		gchar* _tmp9_ = NULL;
		gboolean _tmp10_ = FALSE;
		const gchar* _tmp11_;
		description = NULL;
		g_object_get (object, "description", &_tmp9_, NULL, NULL);
		_g_free0 (description);
		description = _tmp9_;
		_tmp11_ = description;
		if (_tmp11_ != NULL) {
			const gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			_tmp12_ = description;
			_tmp13_ = g_utf8_strdown (_tmp12_, (gssize) -1);
			_tmp14_ = _tmp13_;
			_tmp10_ = string_contains (_tmp14_, text);
			_g_free0 (_tmp14_);
		} else {
			_tmp10_ = FALSE;
		}
		if (_tmp10_) {
			result = TRUE;
			_g_free0 (description);
			_g_free0 (name);
			return result;
		}
		_g_free0 (description);
	}
	result = FALSE;
	_g_free0 (name);
	return result;
}

static gboolean
seahorse_key_manager_store_apply_showfilter (SeahorseKeyManagerStore* self,
                                             GObject* obj)
{
	gboolean result = FALSE;
	SeahorseFlags obj_flags = 0U;
	SeahorseFlags _tmp0_ = 0U;
	SeahorseKeyManagerStoreShowFilter _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	obj_flags = SEAHORSE_FLAG_NONE;
	g_object_get (obj, "object-flags", &_tmp0_, NULL, NULL);
	obj_flags = _tmp0_;
	_tmp1_ = self->priv->_showfilter;
	switch (_tmp1_) {
		case SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_PERSONAL:
		{
			SeahorseFlags _tmp2_;
			_tmp2_ = obj_flags;
			result = (_tmp2_ & SEAHORSE_FLAG_PERSONAL) == SEAHORSE_FLAG_PERSONAL;
			return result;
		}
		case SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_TRUSTED:
		{
			SeahorseFlags _tmp3_;
			_tmp3_ = obj_flags;
			result = (_tmp3_ & SEAHORSE_FLAG_TRUSTED) == SEAHORSE_FLAG_TRUSTED;
			return result;
		}
		case SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_ANY:
		{
			result = TRUE;
			return result;
		}
		default:
		break;
	}
	result = FALSE;
	return result;
}

static gboolean
seahorse_key_manager_store_on_filter_visible (SeahorseKeyManagerStore* self,
                                              GObject* obj)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (seahorse_key_manager_store_apply_showfilter (self, obj)) {
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		_tmp1_ = seahorse_key_manager_store_get_filter (self);
		_tmp2_ = _tmp1_;
		_tmp0_ = seahorse_key_manager_store_object_contains_filtered_text (self, obj, _tmp2_);
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

void
seahorse_key_manager_store_refilter (SeahorseKeyManagerStore* self)
{
	GcrFilterCollection* collection = NULL;
	GcrCollection* _tmp0_;
	GcrCollection* _tmp1_;
	GcrCollection* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gcr_collection_model_get_collection ((GcrCollectionModel*) self);
	_tmp1_ = _tmp0_;
	collection = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gcr_filter_collection_get_type (), GcrFilterCollection);
	gcr_filter_collection_refilter (collection);
	_tmp2_ = gcr_filter_collection_get_underlying (collection);
	g_debug ("key-manager-store.vala:236: %u/%u elements visible after refilter", gcr_collection_get_length ((GcrCollection*) collection), gcr_collection_get_length (_tmp2_));
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < ((glong) 0)) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}

static void
seahorse_key_manager_store_set_sort_to (SeahorseKeyManagerStore* self,
                                        const gchar* name)
{
	GtkSortType _tmp0_ = 0;
	GtkSortType ord = 0;
	gchar* without_sign = NULL;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gint id = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	if (string_get (name, (glong) 0) == '-') {
		_tmp0_ = GTK_SORT_DESCENDING;
	} else {
		_tmp0_ = GTK_SORT_ASCENDING;
	}
	ord = _tmp0_;
	_tmp1_ = g_strdup (name);
	without_sign = _tmp1_;
	if (string_get (name, (glong) 0) == '-') {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = string_get (name, (glong) 0) == '+';
	}
	if (_tmp2_) {
		gchar* _tmp3_;
		_tmp3_ = string_substring (name, (glong) 1, (glong) -1);
		_g_free0 (without_sign);
		without_sign = _tmp3_;
	}
	id = -1;
	{
		gint i = 0;
		i = (gint) (SEAHORSE_KEY_MANAGER_STORE_COLUMN_N_COLS - 1);
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				gchar* n = NULL;
				GcrColumn* _tmp6_;
				gint _tmp6__length1;
				GcrColumn _tmp7_;
				void* _tmp8_;
				gchar* _tmp9_;
				gboolean _tmp10_ = FALSE;
				const gchar* _tmp11_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ - 1;
				}
				_tmp4_ = FALSE;
				if (!(i >= 0)) {
					break;
				}
				_tmp6_ = seahorse_key_manager_store__columns;
				_tmp6__length1 = seahorse_key_manager_store__columns_length1;
				_tmp7_ = _tmp6_[i];
				_tmp8_ = _tmp7_.user_data;
				_tmp9_ = g_strdup ((const gchar*) _tmp8_);
				n = _tmp9_;
				_tmp11_ = n;
				if (_tmp11_ != NULL) {
					const gchar* _tmp12_;
					_tmp12_ = n;
					_tmp10_ = g_strcmp0 (name, _tmp12_) == 0;
				} else {
					_tmp10_ = FALSE;
				}
				if (_tmp10_) {
					id = i;
					_g_free0 (n);
					break;
				}
				_g_free0 (n);
			}
		}
	}
	if (id != -1) {
		GtkSortType _tmp13_;
		_tmp13_ = ord;
		gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) self, id, _tmp13_);
	}
	_g_free0 (without_sign);
}

static void
seahorse_key_manager_store_on_sort_column_changed (SeahorseKeyManagerStore* self,
                                                   GtkTreeSortable* sort)
{
	GSettings* _tmp0_;
	gint column_id = 0;
	GtkSortType ord = 0;
	gint _tmp1_ = 0;
	GtkSortType _tmp2_ = 0;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sort != NULL);
	_tmp0_ = self->priv->_settings;
	if (_tmp0_ == NULL) {
		return;
	}
	_tmp3_ = gtk_tree_sortable_get_sort_column_id ((GtkTreeSortable*) self, &_tmp1_, &_tmp2_);
	column_id = _tmp1_;
	ord = _tmp2_;
	if (_tmp3_) {
		gboolean _tmp4_ = FALSE;
		if (column_id >= 0) {
			_tmp4_ = column_id < ((gint) SEAHORSE_KEY_MANAGER_STORE_COLUMN_N_COLS);
		} else {
			_tmp4_ = FALSE;
		}
		if (_tmp4_) {
			GcrColumn* _tmp5_;
			gint _tmp5__length1;
			GcrColumn _tmp6_;
			void* _tmp7_;
			_tmp5_ = seahorse_key_manager_store__columns;
			_tmp5__length1 = seahorse_key_manager_store__columns_length1;
			_tmp6_ = _tmp5_[column_id];
			_tmp7_ = _tmp6_.user_data;
			if (_tmp7_ != NULL) {
				const gchar* _tmp8_ = NULL;
				GtkSortType _tmp9_;
				gchar* sign = NULL;
				gchar* _tmp10_;
				GSettings* _tmp11_;
				const gchar* _tmp12_;
				GcrColumn* _tmp13_;
				gint _tmp13__length1;
				GcrColumn _tmp14_;
				void* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				_tmp9_ = ord;
				if (_tmp9_ == GTK_SORT_DESCENDING) {
					_tmp8_ = "-";
				} else {
					_tmp8_ = "";
				}
				_tmp10_ = g_strdup (_tmp8_);
				sign = _tmp10_;
				_tmp11_ = self->priv->_settings;
				_tmp12_ = sign;
				_tmp13_ = seahorse_key_manager_store__columns;
				_tmp13__length1 = seahorse_key_manager_store__columns_length1;
				_tmp14_ = _tmp13_[column_id];
				_tmp15_ = _tmp14_.user_data;
				_tmp16_ = g_strconcat (_tmp12_, (const gchar*) _tmp15_, NULL);
				_tmp17_ = _tmp16_;
				g_settings_set_string (_tmp11_, "sort-by", _tmp17_);
				_g_free0 (_tmp17_);
				_g_free0 (sign);
			}
		}
	} else {
		GSettings* _tmp18_;
		_tmp18_ = self->priv->_settings;
		if (_tmp18_ != NULL) {
			GSettings* _tmp19_;
			_tmp19_ = self->priv->_settings;
			g_settings_set_string (_tmp19_, "sort-by", "");
		}
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gchar*
seahorse_key_manager_store_xds_get_atom_value (SeahorseKeyManagerStore* self,
                                               GdkDragContext* context)
{
	gchar* result = NULL;
	GdkWindow* source_window = NULL;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	guint8* ret = NULL;
	gint ret_length1 = 0;
	gint _ret_size_ = 0;
	gint len = 0;
	GdkWindow* _tmp2_;
	gint _tmp3_ = 0;
	guint8* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gboolean _tmp6_;
	g_return_val_if_fail (self != NULL, NULL);
	if (context == NULL) {
		result = NULL;
		return result;
	}
	_tmp0_ = gdk_drag_context_get_source_window (context);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	source_window = _tmp1_;
	_tmp2_ = source_window;
	_tmp6_ = gdk_property_get (_tmp2_, seahorse_key_manager_store_XDS_ATOM, seahorse_key_manager_store_TEXT_ATOM, (gulong) 0, (gulong) SEAHORSE_KEY_MANAGER_STORE_MAX_XDS_ATOM_VAL_LEN, 0, NULL, &_tmp3_, &_tmp5_, &_tmp4_);
	len = _tmp3_;
	ret = (g_free (ret), NULL);
	ret = _tmp4_;
	ret_length1 = _tmp5_;
	_ret_size_ = ret_length1;
	if (_tmp6_) {
		guint8* _tmp7_;
		gint _tmp7__length1;
		guint8* _tmp8_;
		gint _tmp8__length1;
		gchar* _tmp9_;
		_tmp7_ = ret;
		_tmp7__length1 = ret_length1;
		_tmp7_[len] = (guint8) '\0';
		_tmp8_ = ret;
		_tmp8__length1 = ret_length1;
		_tmp9_ = g_strdup ((const gchar*) _tmp8_);
		result = _tmp9_;
		ret = (g_free (ret), NULL);
		_g_object_unref0 (source_window);
		return result;
	}
	result = NULL;
	ret = (g_free (ret), NULL);
	_g_object_unref0 (source_window);
	return result;
}

static gboolean
seahorse_key_manager_store_xds_context_offers_target (SeahorseKeyManagerStore* self,
                                                      GdkDragContext* context,
                                                      GdkAtom target)
{
	gboolean result = FALSE;
	GList* _tmp0_;
	GList* _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = gdk_drag_context_list_targets (context);
	_tmp1_ = g_list_find (_tmp0_, (gpointer) ((guintptr) target));
	result = _tmp1_ != NULL;
	return result;
}

static gboolean
seahorse_key_manager_store_xds_is_dnd_valid_context (SeahorseKeyManagerStore* self,
                                                     GdkDragContext* context)
{
	gboolean result = FALSE;
	gchar* tmp = NULL;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	if (context == NULL) {
		result = FALSE;
		return result;
	}
	tmp = NULL;
	if (seahorse_key_manager_store_xds_context_offers_target (self, context, seahorse_key_manager_store_XDS_ATOM)) {
		gchar* _tmp0_;
		_tmp0_ = seahorse_key_manager_store_xds_get_atom_value (self, context);
		_g_free0 (tmp);
		tmp = _tmp0_;
	}
	_tmp1_ = tmp;
	result = _tmp1_ != NULL;
	_g_free0 (tmp);
	return result;
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8* _tmp3_;
	gint _tmp3__length1;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res;
	_tmp2__length1 = res_length1;
	_tmp3_ = _tmp2_;
	_tmp3__length1 = _tmp2__length1;
	if (result_length1) {
		*result_length1 = _tmp3__length1;
	}
	result = _tmp3_;
	return result;
}

static void
seahorse_key_manager_store_drag_begin (SeahorseKeyManagerStore* self,
                                       GtkWidget* widget,
                                       GdkDragContext* context)
{
	GList* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	g_return_if_fail (context != NULL);
	g_debug ("key-manager-store.vala:323: drag_begin -.");
	_g_free0 (self->priv->drag_destination);
	self->priv->drag_destination = NULL;
	_g_error_free0 (self->priv->drag_error);
	self->priv->drag_error = NULL;
	(self->priv->drag_objects == NULL) ? NULL : (self->priv->drag_objects = (_g_list_free__g_object_unref0_ (self->priv->drag_objects), NULL));
	self->priv->drag_objects = NULL;
	_tmp0_ = seahorse_key_manager_store_get_selected_objects (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_tree_view_get_type (), GtkTreeView));
	(self->priv->drag_objects == NULL) ? NULL : (self->priv->drag_objects = (_g_list_free__g_object_unref0_ (self->priv->drag_objects), NULL));
	self->priv->drag_objects = _tmp0_;
	_tmp1_ = self->priv->drag_objects;
	if (_tmp1_ != NULL) {
		GdkWindow* source_window = NULL;
		GdkWindow* _tmp2_;
		GdkWindow* _tmp3_;
		GdkWindow* _tmp4_;
		guint8* _tmp5_;
		gint _tmp5__length1;
		guint8* _tmp6_;
		gint _tmp6__length1;
		gint _tmp7_;
		gint _tmp8_;
		_tmp2_ = gdk_drag_context_get_source_window (context);
		_tmp3_ = _g_object_ref0 (_tmp2_);
		source_window = _tmp3_;
		_tmp4_ = source_window;
		_tmp5_ = string_get_data (SEAHORSE_KEY_MANAGER_STORE_XDS_FILENAME, &_tmp5__length1);
		_tmp6_ = _tmp5_;
		_tmp6__length1 = _tmp5__length1;
		_tmp7_ = strlen (SEAHORSE_KEY_MANAGER_STORE_XDS_FILENAME);
		_tmp8_ = _tmp7_;
		gdk_property_change (_tmp4_, seahorse_key_manager_store_XDS_ATOM, seahorse_key_manager_store_TEXT_ATOM, 8, GDK_PROP_MODE_REPLACE, (const guchar*) _tmp6_, _tmp8_);
		_g_object_unref0 (source_window);
	}
	g_debug ("key-manager-store.vala:337: drag_begin <--");
}

static gpointer
_g_error_copy0 (gpointer self)
{
	return self ? g_error_copy (self) : NULL;
}

static gboolean
seahorse_key_manager_store_export_to_text (SeahorseKeyManagerStore* self,
                                           GtkSelectionData* selection_data)
{
	gboolean result = FALSE;
	GList* _tmp0_;
	guint8* output = NULL;
	gint output_length1 = 0;
	gint _output_size_ = 0;
	guint count = 0U;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (selection_data != NULL, FALSE);
	_tmp0_ = self->priv->drag_objects;
	if (_tmp0_ == NULL) {
		result = FALSE;
		return result;
	}
	g_debug ("key-manager-store.vala:343: exporting to text");
	count = (guint) 0;
	{
		guint _tmp1_ = 0U;
		GList* _tmp2_;
		guint8* _tmp3_ = NULL;
		size_t _tmp4_ = 0;
		guint _tmp5_;
		_tmp2_ = self->priv->drag_objects;
		_tmp5_ = seahorse_exportable_export_to_text_wait (_tmp2_, &_tmp3_, &_tmp4_, &_inner_error0_);
		output = (g_free (output), NULL);
		output = _tmp3_;
		output_length1 = _tmp4_;
		_output_size_ = output_length1;
		_tmp1_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch5_g_error;
		}
		count = _tmp1_;
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		GError* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp6_ = e;
		_tmp7_ = _g_error_copy0 (_tmp6_);
		_g_error_free0 (self->priv->drag_error);
		self->priv->drag_error = _tmp7_;
		_tmp8_ = self->priv->drag_error;
		_tmp9_ = _tmp8_->message;
		g_message ("key-manager-store.vala:351: error occurred on export: %s", _tmp9_);
		result = FALSE;
		_g_error_free0 (e);
		output = (g_free (output), NULL);
		return result;
	}
	__finally5:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp10_ = FALSE;
		output = (g_free (output), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp10_;
	}
	if (count > ((guint) 0)) {
		guint8* _tmp11_;
		gint _tmp11__length1;
		guint8* _tmp12_;
		gint _tmp12__length1;
		g_debug ("key-manager-store.vala:358: setting selection text");
		_tmp11_ = output;
		_tmp11__length1 = output_length1;
		_tmp12_ = output;
		_tmp12__length1 = output_length1;
		gtk_selection_data_set_text (selection_data, (const gchar*) _tmp11_, _tmp12__length1);
		result = TRUE;
		output = (g_free (output), NULL);
		return result;
	}
	g_message ("key-manager-store.vala:363: no objects exported");
	result = FALSE;
	output = (g_free (output), NULL);
	return result;
}

static gboolean
seahorse_key_manager_store_export_to_directory (SeahorseKeyManagerStore* self,
                                                const gchar* directory)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (directory != NULL, FALSE);
	g_debug ("key-manager-store.vala:368: exporting to %s", directory);
	{
		GList* _tmp0_;
		_tmp0_ = self->priv->drag_objects;
		seahorse_exportable_export_to_directory_wait (_tmp0_, directory, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch6_g_error;
		}
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		GError* _tmp2_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = e;
		_tmp2_ = _g_error_copy0 (_tmp1_);
		_g_error_free0 (self->priv->drag_error);
		self->priv->drag_error = _tmp2_;
		result = FALSE;
		_g_error_free0 (e);
		return result;
	}
	__finally6:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp3_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp3_;
	}
	result = TRUE;
	return result;
}

static void
seahorse_key_manager_store_drag_data_get (SeahorseKeyManagerStore* self,
                                          GtkWidget* widget,
                                          GdkDragContext* context,
                                          GtkSelectionData* selection_data,
                                          guint info,
                                          guint time)
{
	GList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	g_return_if_fail (context != NULL);
	g_return_if_fail (selection_data != NULL);
	_tmp0_ = self->priv->drag_objects;
	if (_tmp0_ == NULL) {
		return;
	}
	g_debug ("key-manager-store.vala:383: drag_data_get %u -.", info);
	if (info == ((guint) SEAHORSE_KEY_MANAGER_STORE_DRAG_INFO_TEXT)) {
		g_debug ("key-manager-store.vala:387: returning object text");
		seahorse_key_manager_store_export_to_text (self, selection_data);
	} else {
		if (info == ((guint) SEAHORSE_KEY_MANAGER_STORE_DRAG_INFO_XDS)) {
			if (seahorse_key_manager_store_xds_is_dnd_valid_context (self, context)) {
				gchar* destination = NULL;
				gchar* _tmp1_;
				const gchar* _tmp2_;
				const gchar* _tmp3_;
				gchar* _tmp4_;
				guint8* _tmp5_;
				gint _tmp5__length1;
				guint8* _tmp6_;
				gint _tmp6__length1;
				_tmp1_ = seahorse_key_manager_store_xds_get_atom_value (self, context);
				destination = _tmp1_;
				_tmp2_ = destination;
				if (_tmp2_ == NULL) {
					_g_free0 (destination);
					return;
				}
				_tmp3_ = destination;
				_tmp4_ = g_path_get_dirname (_tmp3_);
				_g_free0 (self->priv->drag_destination);
				self->priv->drag_destination = _tmp4_;
				_tmp5_ = string_get_data ("S", &_tmp5__length1);
				_tmp6_ = _tmp5_;
				_tmp6__length1 = _tmp5__length1;
				gtk_selection_data_set (selection_data, gtk_selection_data_get_target (selection_data), 8, _tmp6_, (gint) _tmp6__length1);
				_g_free0 (destination);
			}
		} else {
			g_debug ("key-manager-store.vala:404: Unrecognized format: %u", info);
		}
	}
	g_debug ("key-manager-store.vala:407: drag_data_get <--");
}

static void
seahorse_key_manager_store_drag_end (SeahorseKeyManagerStore* self,
                                     GtkWidget* widget,
                                     GdkDragContext* context)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	GError* _tmp4_;
	g_return_if_fail (self != NULL);
	g_debug ("key-manager-store.vala:411: drag_end -.");
	_tmp1_ = self->priv->drag_destination;
	if (_tmp1_ != NULL) {
		GError* _tmp2_;
		_tmp2_ = self->priv->drag_error;
		_tmp0_ = _tmp2_ == NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		const gchar* _tmp3_;
		_tmp3_ = self->priv->drag_destination;
		seahorse_key_manager_store_export_to_directory (self, _tmp3_);
	}
	_tmp4_ = self->priv->drag_error;
	if (_tmp4_ != NULL) {
		GError* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
		_tmp5_ = self->priv->drag_error;
		g_dbus_error_strip_remote_error (_tmp5_);
		_tmp6_ = self->priv->drag_error;
		_tmp7_ = _tmp6_->message;
		seahorse_util_show_error (widget, _ ("Couldn’t export keys"), _tmp7_);
	}
	_g_error_free0 (self->priv->drag_error);
	self->priv->drag_error = NULL;
	(self->priv->drag_objects == NULL) ? NULL : (self->priv->drag_objects = (_g_list_free__g_object_unref0_ (self->priv->drag_objects), NULL));
	self->priv->drag_objects = NULL;
	_g_free0 (self->priv->drag_destination);
	self->priv->drag_destination = NULL;
	g_debug ("key-manager-store.vala:425: drag_end <--");
}

static GtkTreeIter*
_gtk_tree_iter_dup (GtkTreeIter* self)
{
	GtkTreeIter* dup;
	dup = g_new0 (GtkTreeIter, 1);
	memcpy (dup, self, sizeof (GtkTreeIter));
	return dup;
}

static gpointer
__gtk_tree_iter_dup0 (gpointer self)
{
	return self ? _gtk_tree_iter_dup (self) : NULL;
}

GObject*
seahorse_key_manager_store_get_object_from_path (GtkTreeView* view,
                                                 GtkTreePath* path)
{
	GObject* result = NULL;
	GtkTreeIter* iter = NULL;
	GtkTreeModel* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeIter _tmp2_ = {0};
	gboolean _tmp3_;
	GtkTreeIter _tmp4_;
	GtkTreeIter* _tmp5_;
	GtkTreeModel* _tmp6_;
	GtkTreeModel* _tmp7_;
	GtkTreeIter* _tmp8_;
	GtkTreeIter _tmp9_;
	GObject* _tmp10_;
	GObject* _tmp11_;
	g_return_val_if_fail (view != NULL, NULL);
	_tmp0_ = gtk_tree_view_get_model (view);
	_tmp1_ = _tmp0_;
	_tmp3_ = gtk_tree_model_get_iter (_tmp1_, &_tmp2_, path);
	_g_free0 (iter);
	_tmp4_ = _tmp2_;
	_tmp5_ = __gtk_tree_iter_dup0 (&_tmp4_);
	iter = _tmp5_;
	if (!_tmp3_) {
		result = NULL;
		_g_free0 (iter);
		return result;
	}
	_tmp6_ = gtk_tree_view_get_model (view);
	_tmp7_ = _tmp6_;
	_tmp8_ = iter;
	_tmp9_ = *_tmp8_;
	_tmp10_ = gcr_collection_model_object_for_iter (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gcr_collection_model_get_type (), GcrCollectionModel), &_tmp9_);
	_tmp11_ = _g_object_ref0 (_tmp10_);
	result = _tmp11_;
	_g_free0 (iter);
	return result;
}

GList*
seahorse_key_manager_store_get_all_objects (SeahorseKeyManagerStore* self)
{
	GList* result = NULL;
	GcrCollection* _tmp0_;
	GList* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gcr_collection_model_get_collection ((GcrCollectionModel*) self);
	_tmp1_ = gcr_collection_get_objects (_tmp0_);
	result = _tmp1_;
	return result;
}

static GtkTreePath*
_vala_GtkTreePath_copy (GtkTreePath* self)
{
	return g_boxed_copy (gtk_tree_path_get_type (), self);
}

static gpointer
__vala_GtkTreePath_copy0 (gpointer self)
{
	return self ? _vala_GtkTreePath_copy (self) : NULL;
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
	g_boxed_free (gtk_tree_path_get_type (), self);
}

static gint
__lambda15_ (GObject* a,
             GObject* b)
{
	gint result = 0;
	gint _tmp0_ = 0;
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	if (a == b) {
		result = 0;
		return result;
	}
	if (((void*) a) > ((void*) b)) {
		_tmp0_ = 1;
	} else {
		_tmp0_ = -1;
	}
	result = _tmp0_;
	return result;
}

static gint
___lambda15__gcompare_func (gconstpointer a,
                            gconstpointer b)
{
	gint result;
	result = __lambda15_ ((GObject*) a, (GObject*) b);
	return result;
}

static void
__vala_GtkTreePath_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL));
}

static inline void
_g_list_free___vala_GtkTreePath_free0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) __vala_GtkTreePath_free0_);
}

GList*
seahorse_key_manager_store_get_selected_objects (GtkTreeView* view)
{
	GList* result = NULL;
	GList* paths = NULL;
	GtkTreeSelection* _tmp0_;
	GList* _tmp1_;
	GList* objects = NULL;
	GList* _tmp2_;
	GList* l = NULL;
	g_return_val_if_fail (view != NULL, NULL);
	_tmp0_ = gtk_tree_view_get_selection (view);
	_tmp1_ = gtk_tree_selection_get_selected_rows (_tmp0_, NULL);
	paths = _tmp1_;
	objects = NULL;
	_tmp2_ = paths;
	{
		GList* path_collection = NULL;
		GList* path_it = NULL;
		path_collection = _tmp2_;
		for (path_it = path_collection; path_it != NULL; path_it = path_it->next) {
			GtkTreePath* _tmp3_;
			GtkTreePath* path = NULL;
			_tmp3_ = __vala_GtkTreePath_copy0 ((GtkTreePath*) path_it->data);
			path = _tmp3_;
			{
				GObject* obj = NULL;
				GtkTreePath* _tmp4_;
				GObject* _tmp5_;
				GObject* _tmp6_;
				_tmp4_ = path;
				_tmp5_ = seahorse_key_manager_store_get_object_from_path (view, _tmp4_);
				obj = _tmp5_;
				_tmp6_ = obj;
				if (_tmp6_ != NULL) {
					GObject* _tmp7_;
					GObject* _tmp8_;
					_tmp7_ = obj;
					_tmp8_ = _g_object_ref0 (_tmp7_);
					objects = g_list_append (objects, _tmp8_);
				}
				_g_object_unref0 (obj);
				__vala_GtkTreePath_free0 (path);
			}
		}
	}
	objects = g_list_sort (objects, ___lambda15__gcompare_func);
	l = NULL;
	{
		GList* _tmp9_;
		gboolean _tmp10_ = FALSE;
		_tmp9_ = objects;
		l = _tmp9_;
		_tmp10_ = TRUE;
		while (TRUE) {
			GList* _tmp13_;
			if (!_tmp10_) {
				GList* _tmp11_;
				GList* _tmp12_;
				_tmp11_ = l;
				_tmp12_ = _tmp11_->next;
				l = _tmp12_;
			}
			_tmp10_ = FALSE;
			_tmp13_ = l;
			if (!(_tmp13_ != NULL)) {
				break;
			}
			while (TRUE) {
				gboolean _tmp14_ = FALSE;
				GList* _tmp15_;
				GList* _tmp16_;
				GList* _tmp22_;
				GList* _tmp23_;
				_tmp15_ = l;
				_tmp16_ = _tmp15_->next;
				if (_tmp16_ != NULL) {
					GList* _tmp17_;
					gconstpointer _tmp18_;
					GList* _tmp19_;
					GList* _tmp20_;
					gconstpointer _tmp21_;
					_tmp17_ = l;
					_tmp18_ = _tmp17_->data;
					_tmp19_ = l;
					_tmp20_ = _tmp19_->next;
					_tmp21_ = _tmp20_->data;
					_tmp14_ = ((GObject*) _tmp18_) == ((GObject*) _tmp21_);
				} else {
					_tmp14_ = FALSE;
				}
				if (!_tmp14_) {
					break;
				}
				_tmp22_ = l;
				_tmp23_ = _tmp22_->next;
				objects = g_list_delete_link (objects, _tmp23_);
			}
		}
	}
	result = objects;
	(paths == NULL) ? NULL : (paths = (_g_list_free___vala_GtkTreePath_free0_ (paths), NULL));
	return result;
}

void
seahorse_key_manager_store_set_selected_objects (GtkTreeView* view,
                                                 GList* objects)
{
	GtkTreeSelection* selection = NULL;
	GtkTreeSelection* _tmp0_;
	GtkTreeSelection* _tmp1_;
	GtkTreeSelection* _tmp2_;
	gboolean first = FALSE;
	g_return_if_fail (view != NULL);
	_tmp0_ = gtk_tree_view_get_selection (view);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	selection = _tmp1_;
	_tmp2_ = selection;
	gtk_tree_selection_unselect_all (_tmp2_);
	first = TRUE;
	{
		GList* obj_collection = NULL;
		GList* obj_it = NULL;
		obj_collection = objects;
		for (obj_it = obj_collection; obj_it != NULL; obj_it = obj_it->next) {
			GObject* _tmp3_;
			GObject* obj = NULL;
			_tmp3_ = _g_object_ref0 ((GObject*) obj_it->data);
			obj = _tmp3_;
			{
				GtkTreeIter iter = {0};
				GtkTreeModel* _tmp4_;
				GtkTreeModel* _tmp5_;
				GObject* _tmp6_;
				GtkTreeIter _tmp7_;
				memset (&iter, 0, sizeof (GtkTreeIter));
				_tmp4_ = gtk_tree_view_get_model (view);
				_tmp5_ = _tmp4_;
				_tmp6_ = obj;
				_tmp7_ = iter;
				if (gcr_collection_model_iter_for_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gcr_collection_model_get_type (), GcrCollectionModel), _tmp6_, &_tmp7_)) {
					GtkTreeSelection* _tmp8_;
					GtkTreeIter _tmp9_;
					_tmp8_ = selection;
					_tmp9_ = iter;
					gtk_tree_selection_select_iter (_tmp8_, &_tmp9_);
					if (first) {
						GtkTreePath* path = NULL;
						GtkTreeModel* _tmp10_;
						GtkTreeModel* _tmp11_;
						GtkTreeIter _tmp12_;
						GtkTreePath* _tmp13_;
						GtkTreePath* _tmp14_;
						_tmp10_ = gtk_tree_view_get_model (view);
						_tmp11_ = _tmp10_;
						_tmp12_ = iter;
						_tmp13_ = gtk_tree_model_get_path (_tmp11_, &_tmp12_);
						path = _tmp13_;
						_tmp14_ = path;
						gtk_tree_view_scroll_to_cell (view, _tmp14_, NULL, FALSE, 0.0f, 0.0f);
						first = FALSE;
						__vala_GtkTreePath_free0 (path);
					}
				}
				_g_object_unref0 (obj);
			}
		}
	}
	_g_object_unref0 (selection);
}

GObject*
seahorse_key_manager_store_get_selected_object (SeahorseKeyManagerStore* self,
                                                GtkTreeView* view)
{
	GObject* result = NULL;
	GList* paths = NULL;
	GtkTreeSelection* _tmp0_;
	GList* _tmp1_;
	GObject* obj = NULL;
	GList* _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gtk_tree_view_get_selection (view);
	_tmp1_ = gtk_tree_selection_get_selected_rows (_tmp0_, NULL);
	paths = _tmp1_;
	obj = NULL;
	_tmp2_ = paths;
	if (_tmp2_ != NULL) {
		GList* _tmp3_;
		gconstpointer _tmp4_;
		GObject* _tmp5_;
		_tmp3_ = paths;
		_tmp4_ = _tmp3_->data;
		_tmp5_ = seahorse_key_manager_store_get_object_from_path (view, (GtkTreePath*) _tmp4_);
		_g_object_unref0 (obj);
		obj = _tmp5_;
	}
	result = obj;
	(paths == NULL) ? NULL : (paths = (_g_list_free___vala_GtkTreePath_free0_ (paths), NULL));
	return result;
}

GSettings*
seahorse_key_manager_store_get_settings (SeahorseKeyManagerStore* self)
{
	GSettings* result;
	GSettings* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_settings;
	result = _tmp0_;
	return result;
}

void
seahorse_key_manager_store_set_settings (SeahorseKeyManagerStore* self,
                                         GSettings* value)
{
	g_return_if_fail (self != NULL);
	if (seahorse_key_manager_store_get_settings (self) != value) {
		GSettings* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_settings);
		self->priv->_settings = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, seahorse_key_manager_store_properties[SEAHORSE_KEY_MANAGER_STORE_SETTINGS_PROPERTY]);
	}
}

const gchar*
seahorse_key_manager_store_get_filter (SeahorseKeyManagerStore* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_filter;
	result = _tmp0_;
	return result;
}

void
seahorse_key_manager_store_set_filter (SeahorseKeyManagerStore* self,
                                       const gchar* value)
{
	const gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_filter;
	if (g_strcmp0 (_tmp0_, value) != 0) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup (value);
		_g_free0 (self->priv->_filter);
		self->priv->_filter = _tmp1_;
		seahorse_key_manager_store_refilter (self);
	}
	g_object_notify_by_pspec ((GObject *) self, seahorse_key_manager_store_properties[SEAHORSE_KEY_MANAGER_STORE_FILTER_PROPERTY]);
}

SeahorseKeyManagerStoreShowFilter
seahorse_key_manager_store_get_showfilter (SeahorseKeyManagerStore* self)
{
	SeahorseKeyManagerStoreShowFilter result;
	SeahorseKeyManagerStoreShowFilter _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_showfilter;
	result = _tmp0_;
	return result;
}

void
seahorse_key_manager_store_set_showfilter (SeahorseKeyManagerStore* self,
                                           SeahorseKeyManagerStoreShowFilter value)
{
	g_return_if_fail (self != NULL);
	if (seahorse_key_manager_store_get_showfilter (self) != value) {
		self->priv->_showfilter = value;
		g_object_notify_by_pspec ((GObject *) self, seahorse_key_manager_store_properties[SEAHORSE_KEY_MANAGER_STORE_SHOWFILTER_PROPERTY]);
	}
}

static GObject *
seahorse_key_manager_store_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SeahorseKeyManagerStore * self;
	GcrColumn* _tmp0_;
	gint _tmp0__length1;
	parent_class = G_OBJECT_CLASS (seahorse_key_manager_store_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_KEY_MANAGER_STORE, SeahorseKeyManagerStore);
	_tmp0_ = seahorse_key_manager_store__columns;
	_tmp0__length1 = seahorse_key_manager_store__columns_length1;
	g_object_set ((GObject*) self, "columns", _tmp0_, "mode", GCR_COLLECTION_MODEL_LIST, NULL, NULL);
	return obj;
}

static void
seahorse_key_manager_store_class_init (SeahorseKeyManagerStoreClass * klass,
                                       gpointer klass_data)
{
	GcrColumn _tmp0_ = {0};
	GcrColumn _tmp1_ = {0};
	GcrColumn _tmp2_ = {0};
	GcrColumn _tmp3_ = {0};
	GcrColumn _tmp4_ = {0};
	GcrColumn* _tmp5_;
	seahorse_key_manager_store_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SeahorseKeyManagerStore_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_key_manager_store_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_key_manager_store_set_property;
	G_OBJECT_CLASS (klass)->constructor = seahorse_key_manager_store_constructor;
	G_OBJECT_CLASS (klass)->finalize = seahorse_key_manager_store_finalize;
	/**
	     * Manager Settings
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_KEY_MANAGER_STORE_SETTINGS_PROPERTY, seahorse_key_manager_store_properties[SEAHORSE_KEY_MANAGER_STORE_SETTINGS_PROPERTY] = g_param_spec_object ("settings", "settings", "settings", g_settings_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	/**
	     * Key store filter
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_KEY_MANAGER_STORE_FILTER_PROPERTY, seahorse_key_manager_store_properties[SEAHORSE_KEY_MANAGER_STORE_FILTER_PROPERTY] = g_param_spec_string ("filter", "filter", "filter", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_KEY_MANAGER_STORE_SHOWFILTER_PROPERTY, seahorse_key_manager_store_properties[SEAHORSE_KEY_MANAGER_STORE_SHOWFILTER_PROPERTY] = g_param_spec_enum ("showfilter", "showfilter", "showfilter", SEAHORSE_KEY_MANAGER_STORE_TYPE_SHOW_FILTER, SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_ANY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	seahorse_key_manager_store_XDS_ATOM = gdk_atom_intern ("XdndDirectSave0", FALSE);
	seahorse_key_manager_store_TEXT_ATOM = gdk_atom_intern ("text/plain", FALSE);
	memset (&_tmp0_, 0, sizeof (GcrColumn));
	_tmp0_.property_name = "icon";
	_tmp0_.property_type = g_icon_get_type ();
	_tmp0_.column_type = g_icon_get_type ();
	memset (&_tmp1_, 0, sizeof (GcrColumn));
	_tmp1_.property_name = "markup";
	_tmp1_.property_type = G_TYPE_STRING;
	_tmp1_.column_type = G_TYPE_STRING;
	memset (&_tmp2_, 0, sizeof (GcrColumn));
	_tmp2_.property_name = "label";
	_tmp2_.property_type = G_TYPE_STRING;
	_tmp2_.column_type = G_TYPE_STRING;
	_tmp2_.flags = GCR_COLUMN_SORTABLE;
	memset (&_tmp3_, 0, sizeof (GcrColumn));
	_tmp3_.property_name = "description";
	_tmp3_.property_type = G_TYPE_STRING;
	_tmp3_.column_type = G_TYPE_STRING;
	memset (&_tmp4_, 0, sizeof (GcrColumn));
	_tmp5_ = g_new0 (GcrColumn, 5);
	_tmp5_[0] = _tmp0_;
	_tmp5_[1] = _tmp1_;
	_tmp5_[2] = _tmp2_;
	_tmp5_[3] = _tmp3_;
	_tmp5_[4] = _tmp4_;
	seahorse_key_manager_store__columns = _tmp5_;
	seahorse_key_manager_store__columns_length1 = 5;
}

static void
seahorse_key_manager_store_instance_init (SeahorseKeyManagerStore * self,
                                          gpointer klass)
{
	gchar* _tmp0_;
	self->priv = seahorse_key_manager_store_get_instance_private (self);
	_tmp0_ = g_strdup ("");
	self->priv->_filter = _tmp0_;
	self->priv->_showfilter = SEAHORSE_KEY_MANAGER_STORE_SHOW_FILTER_ANY;
}

static void
seahorse_key_manager_store_finalize (GObject * obj)
{
	SeahorseKeyManagerStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_KEY_MANAGER_STORE, SeahorseKeyManagerStore);
	g_signal_handlers_disconnect_by_func ((void*) self, (void*) seahorse_key_manager_store_on_sort_column_changed, (void*) self);
	_g_free0 (self->priv->drag_destination);
	_g_error_free0 (self->priv->drag_error);
	(self->priv->drag_objects == NULL) ? NULL : (self->priv->drag_objects = (_g_list_free__g_object_unref0_ (self->priv->drag_objects), NULL));
	_g_object_unref0 (self->priv->_settings);
	_g_free0 (self->priv->_filter);
	G_OBJECT_CLASS (seahorse_key_manager_store_parent_class)->finalize (obj);
}

GType
seahorse_key_manager_store_get_type (void)
{
	static volatile gsize seahorse_key_manager_store_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_key_manager_store_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SeahorseKeyManagerStoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_key_manager_store_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseKeyManagerStore), 0, (GInstanceInitFunc) seahorse_key_manager_store_instance_init, NULL };
		GType seahorse_key_manager_store_type_id;
		seahorse_key_manager_store_type_id = g_type_register_static (gcr_collection_model_get_type (), "SeahorseKeyManagerStore", &g_define_type_info, 0);
		SeahorseKeyManagerStore_private_offset = g_type_add_instance_private (seahorse_key_manager_store_type_id, sizeof (SeahorseKeyManagerStorePrivate));
		g_once_init_leave (&seahorse_key_manager_store_type_id__volatile, seahorse_key_manager_store_type_id);
	}
	return seahorse_key_manager_store_type_id__volatile;
}

static void
_vala_seahorse_key_manager_store_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	SeahorseKeyManagerStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_KEY_MANAGER_STORE, SeahorseKeyManagerStore);
	switch (property_id) {
		case SEAHORSE_KEY_MANAGER_STORE_SETTINGS_PROPERTY:
		g_value_set_object (value, seahorse_key_manager_store_get_settings (self));
		break;
		case SEAHORSE_KEY_MANAGER_STORE_FILTER_PROPERTY:
		g_value_set_string (value, seahorse_key_manager_store_get_filter (self));
		break;
		case SEAHORSE_KEY_MANAGER_STORE_SHOWFILTER_PROPERTY:
		g_value_set_enum (value, seahorse_key_manager_store_get_showfilter (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_seahorse_key_manager_store_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	SeahorseKeyManagerStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_KEY_MANAGER_STORE, SeahorseKeyManagerStore);
	switch (property_id) {
		case SEAHORSE_KEY_MANAGER_STORE_SETTINGS_PROPERTY:
		seahorse_key_manager_store_set_settings (self, g_value_get_object (value));
		break;
		case SEAHORSE_KEY_MANAGER_STORE_FILTER_PROPERTY:
		seahorse_key_manager_store_set_filter (self, g_value_get_string (value));
		break;
		case SEAHORSE_KEY_MANAGER_STORE_SHOWFILTER_PROPERTY:
		seahorse_key_manager_store_set_showfilter (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

