/* servers.c generated by valac 0.44.7, the Vala compiler
 * generated from servers.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2008 Stefan Walter
 * Copyright (C) 2017 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <gio/gio.h>

typedef gboolean (*SeahorseValidUriFunc) (const gchar* uri);

#define SEAHORSE_SERVERS_TYPE_SERVER_INFO (seahorse_servers_server_info_get_type ())
typedef struct _SeahorseServersServerInfo SeahorseServersServerInfo;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block7Data Block7Data;
#define _seahorse_servers_server_info_free0(var) ((var == NULL) ? NULL : (var = (seahorse_servers_server_info_free (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

#define SEAHORSE_TYPE_PGP_SETTINGS (seahorse_pgp_settings_get_type ())
#define SEAHORSE_PGP_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_TYPE_PGP_SETTINGS, SeahorsePgpSettings))
#define SEAHORSE_PGP_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_TYPE_PGP_SETTINGS, SeahorsePgpSettingsClass))
#define SEAHORSE_IS_PGP_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_TYPE_PGP_SETTINGS))
#define SEAHORSE_IS_PGP_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_TYPE_PGP_SETTINGS))
#define SEAHORSE_PGP_SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_TYPE_PGP_SETTINGS, SeahorsePgpSettingsClass))

typedef struct _SeahorsePgpSettings SeahorsePgpSettings;
typedef struct _SeahorsePgpSettingsClass SeahorsePgpSettingsClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SeahorseServersServerInfo {
	gchar* type;
	gchar* description;
	SeahorseValidUriFunc validator;
};

struct _Block7Data {
	int _ref_count_;
	gchar** types;
	gint types_length1;
	gint _types_size_;
};

extern GHashTable* seahorse_servers_server_types;
GHashTable* seahorse_servers_server_types = NULL;

GType seahorse_servers_server_info_get_type (void) G_GNUC_CONST;
SeahorseServersServerInfo* seahorse_servers_server_info_dup (const SeahorseServersServerInfo* self);
void seahorse_servers_server_info_free (SeahorseServersServerInfo* self);
void seahorse_servers_server_info_copy (const SeahorseServersServerInfo* self,
                                        SeahorseServersServerInfo* dest);
void seahorse_servers_server_info_destroy (SeahorseServersServerInfo* self);
gchar** seahorse_servers_get_types (void);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void ___lambda10_ (Block7Data* _data7_,
                   const gchar* uri,
                   SeahorseServersServerInfo* server_info);
static void _vala_array_add2 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
static void ____lambda10__gh_func (gconstpointer key,
                            gconstpointer value,
                            gpointer self);
static gchar** _vala_array_dup1 (gchar** self,
                          int length);
gchar* seahorse_servers_get_description (const gchar* type);
void seahorse_servers_register_type (const gchar* type,
                                     const gchar* description,
                                     SeahorseValidUriFunc validate);
static void _g_free0_ (gpointer var);
static void _seahorse_servers_server_info_free0_ (gpointer var);
void seahorse_servers_cleanup (void);
gchar** seahorse_servers_get_uris (void);
GType seahorse_pgp_settings_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SeahorsePgpSettings, g_object_unref)
SeahorsePgpSettings* seahorse_pgp_settings_instance (void);
gchar** seahorse_pgp_settings_get_keyservers (SeahorsePgpSettings* self,
                                              gint* result_length1);
static void _vala_array_add3 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
gchar** seahorse_servers_get_names (void);
static void _vala_array_add4 (gchar** * array,
                       int* length,
                       int* size,
                       gchar* value);
gboolean seahorse_servers_is_valid_uri (const gchar* uri);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

void
seahorse_servers_server_info_copy (const SeahorseServersServerInfo* self,
                                   SeahorseServersServerInfo* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	SeahorseValidUriFunc _tmp4_;
	_tmp0_ = (*self).type;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).type);
	(*dest).type = _tmp1_;
	_tmp2_ = (*self).description;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).description);
	(*dest).description = _tmp3_;
	_tmp4_ = (*self).validator;
	(*dest).validator = _tmp4_;
}

void
seahorse_servers_server_info_destroy (SeahorseServersServerInfo* self)
{
	_g_free0 ((*self).type);
	_g_free0 ((*self).description);
}

SeahorseServersServerInfo*
seahorse_servers_server_info_dup (const SeahorseServersServerInfo* self)
{
	SeahorseServersServerInfo* dup;
	dup = g_new0 (SeahorseServersServerInfo, 1);
	seahorse_servers_server_info_copy (self, dup);
	return dup;
}

void
seahorse_servers_server_info_free (SeahorseServersServerInfo* self)
{
	seahorse_servers_server_info_destroy (self);
	g_free (self);
}

GType
seahorse_servers_server_info_get_type (void)
{
	static volatile gsize seahorse_servers_server_info_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_servers_server_info_type_id__volatile)) {
		GType seahorse_servers_server_info_type_id;
		seahorse_servers_server_info_type_id = g_boxed_type_register_static ("SeahorseServersServerInfo", (GBoxedCopyFunc) seahorse_servers_server_info_dup, (GBoxedFreeFunc) seahorse_servers_server_info_free);
		g_once_init_leave (&seahorse_servers_server_info_type_id__volatile, seahorse_servers_server_info_type_id);
	}
	return seahorse_servers_server_info_type_id__volatile;
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		_data7_->types = (_vala_array_free (_data7_->types, _data7_->types_length1, (GDestroyNotify) g_free), NULL);
		g_slice_free (Block7Data, _data7_);
	}
}

static void
_vala_array_add2 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
___lambda10_ (Block7Data* _data7_,
              const gchar* uri,
              SeahorseServersServerInfo* server_info)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_if_fail (uri != NULL);
	_tmp0_ = _data7_->types;
	_tmp0__length1 = _data7_->types_length1;
	_tmp1_ = (*server_info).type;
	_tmp2_ = g_strdup (_tmp1_);
	_vala_array_add2 (&_data7_->types, &_data7_->types_length1, &_data7_->_types_size_, _tmp2_);
}

static void
____lambda10__gh_func (gconstpointer key,
                       gconstpointer value,
                       gpointer self)
{
	___lambda10_ (self, (const gchar*) key, (SeahorseServersServerInfo*) value);
}

static gchar**
_vala_array_dup1 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}

gchar**
seahorse_servers_get_types (void)
{
	gchar** result = NULL;
	Block7Data* _data7_;
	gchar** _tmp0_;
	GHashTable* _tmp1_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp4_;
	gint _tmp4__length1;
	_data7_ = g_slice_new0 (Block7Data);
	_data7_->_ref_count_ = 1;
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	_data7_->types = _tmp0_;
	_data7_->types_length1 = 0;
	_data7_->_types_size_ = _data7_->types_length1;
	_tmp1_ = seahorse_servers_server_types;
	if (_tmp1_ != NULL) {
		GHashTable* _tmp2_;
		_tmp2_ = seahorse_servers_server_types;
		g_hash_table_foreach (_tmp2_, ____lambda10__gh_func, _data7_);
	}
	_tmp3_ = _data7_->types;
	_tmp3__length1 = _data7_->types_length1;
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup1 (_tmp3_, _tmp3__length1) : ((gpointer) _tmp3_);
	_tmp4__length1 = _tmp3__length1;
	result = _tmp4_;
	block7_data_unref (_data7_);
	_data7_ = NULL;
	return result;
}

static gpointer
_seahorse_servers_server_info_dup0 (gpointer self)
{
	return self ? seahorse_servers_server_info_dup (self) : NULL;
}

gchar*
seahorse_servers_get_description (const gchar* type)
{
	gchar* result = NULL;
	GHashTable* _tmp0_;
	SeahorseServersServerInfo* info = NULL;
	GHashTable* _tmp1_;
	gconstpointer _tmp2_;
	SeahorseServersServerInfo* _tmp3_;
	SeahorseServersServerInfo* _tmp4_;
	_tmp0_ = seahorse_servers_server_types;
	if (_tmp0_ == NULL) {
		result = NULL;
		return result;
	}
	_tmp1_ = seahorse_servers_server_types;
	_tmp2_ = g_hash_table_lookup (_tmp1_, type);
	_tmp3_ = _seahorse_servers_server_info_dup0 ((SeahorseServersServerInfo*) _tmp2_);
	info = _tmp3_;
	_tmp4_ = info;
	if (_tmp4_ != NULL) {
		SeahorseServersServerInfo* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp5_ = info;
		_tmp6_ = (*_tmp5_).description;
		_tmp7_ = g_strdup (_tmp6_);
		result = _tmp7_;
		_seahorse_servers_server_info_free0 (info);
		return result;
	}
	result = NULL;
	_seahorse_servers_server_info_free0 (info);
	return result;
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static void
_seahorse_servers_server_info_free0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (seahorse_servers_server_info_free (var), NULL));
}

void
seahorse_servers_register_type (const gchar* type,
                                const gchar* description,
                                SeahorseValidUriFunc validate)
{
	SeahorseServersServerInfo info = {0};
	gchar* _tmp0_;
	gchar* _tmp1_;
	SeahorseServersServerInfo _tmp2_ = {0};
	GHashTable* _tmp3_;
	GHashTable* _tmp7_;
	SeahorseServersServerInfo _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	SeahorseServersServerInfo _tmp11_;
	SeahorseServersServerInfo _tmp12_;
	SeahorseServersServerInfo* _tmp13_;
	_tmp0_ = g_strdup (description);
	_tmp1_ = g_strdup (type);
	memset (&_tmp2_, 0, sizeof (SeahorseServersServerInfo));
	_g_free0 (_tmp2_.description);
	_tmp2_.description = _tmp0_;
	_g_free0 (_tmp2_.type);
	_tmp2_.type = _tmp1_;
	_tmp2_.validator = validate;
	info = _tmp2_;
	_tmp3_ = seahorse_servers_server_types;
	if (_tmp3_ == NULL) {
		GHashFunc _tmp4_;
		GEqualFunc _tmp5_;
		GHashTable* _tmp6_;
		_tmp4_ = g_str_hash;
		_tmp5_ = g_str_equal;
		_tmp6_ = g_hash_table_new_full (_tmp4_, _tmp5_, _g_free0_, _seahorse_servers_server_info_free0_);
		_g_hash_table_unref0 (seahorse_servers_server_types);
		seahorse_servers_server_types = _tmp6_;
	}
	_tmp7_ = seahorse_servers_server_types;
	_tmp8_ = info;
	_tmp9_ = _tmp8_.type;
	_tmp10_ = g_strdup (_tmp9_);
	_tmp11_ = info;
	_tmp12_ = _tmp11_;
	_tmp13_ = _seahorse_servers_server_info_dup0 (&_tmp12_);
	g_hash_table_replace (_tmp7_, _tmp10_, _tmp13_);
	seahorse_servers_server_info_destroy (&info);
}

void
seahorse_servers_cleanup (void)
{
	_g_hash_table_unref0 (seahorse_servers_server_types);
	seahorse_servers_server_types = NULL;
}

static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}

static void
_vala_array_add3 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

gchar**
seahorse_servers_get_uris (void)
{
	gchar** result = NULL;
	gchar** uris = NULL;
	gchar** _tmp0_;
	gint uris_length1;
	gint _uris_size_;
	SeahorsePgpSettings* _tmp1_;
	SeahorsePgpSettings* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp5_;
	gint _tmp5__length1;
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	uris = _tmp0_;
	uris_length1 = 0;
	_uris_size_ = uris_length1;
	_tmp1_ = seahorse_pgp_settings_instance ();
	_tmp2_ = _tmp1_;
	_tmp3_ = seahorse_pgp_settings_get_keyservers (_tmp2_, &_tmp3__length1);
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _tmp3__length1;
	_tmp5_ = _tmp4_;
	_tmp5__length1 = _tmp4__length1;
	_g_object_unref0 (_tmp2_);
	{
		gchar** server_collection = NULL;
		gint server_collection_length1 = 0;
		gint _server_collection_size_ = 0;
		gint server_it = 0;
		server_collection = _tmp5_;
		server_collection_length1 = _tmp5__length1;
		for (server_it = 0; server_it < server_collection_length1; server_it = server_it + 1) {
			gchar* _tmp6_;
			gchar* server = NULL;
			_tmp6_ = g_strdup (server_collection[server_it]);
			server = _tmp6_;
			{
				gchar** _tmp7_;
				gint _tmp7__length1;
				const gchar* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gchar** _tmp11_;
				gchar** _tmp12_;
				gchar** _tmp13_;
				gint _tmp13__length1;
				const gchar* _tmp14_;
				gchar* _tmp15_;
				_tmp7_ = uris;
				_tmp7__length1 = uris_length1;
				_tmp8_ = server;
				_tmp9_ = string_strip (_tmp8_);
				_tmp10_ = _tmp9_;
				_tmp12_ = _tmp11_ = g_strsplit (_tmp10_, " ", 2);
				_tmp13_ = _tmp12_;
				_tmp13__length1 = _vala_array_length (_tmp11_);
				_tmp14_ = _tmp13_[0];
				_tmp15_ = g_strdup (_tmp14_);
				_vala_array_add3 (&uris, &uris_length1, &_uris_size_, _tmp15_);
				_tmp13_ = (_vala_array_free (_tmp13_, _tmp13__length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (_tmp10_);
				_g_free0 (server);
			}
		}
		server_collection = (_vala_array_free (server_collection, server_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	result = uris;
	return result;
}

static void
_vala_array_add4 (gchar** * array,
                  int* length,
                  int* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

gchar**
seahorse_servers_get_names (void)
{
	gchar** result = NULL;
	gchar** names = NULL;
	gchar** _tmp0_;
	gint names_length1;
	gint _names_size_;
	SeahorsePgpSettings* _tmp1_;
	SeahorsePgpSettings* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp5_;
	gint _tmp5__length1;
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	names = _tmp0_;
	names_length1 = 0;
	_names_size_ = names_length1;
	_tmp1_ = seahorse_pgp_settings_instance ();
	_tmp2_ = _tmp1_;
	_tmp3_ = seahorse_pgp_settings_get_keyservers (_tmp2_, &_tmp3__length1);
	_tmp4_ = _tmp3_;
	_tmp4__length1 = _tmp3__length1;
	_tmp5_ = _tmp4_;
	_tmp5__length1 = _tmp4__length1;
	_g_object_unref0 (_tmp2_);
	{
		gchar** server_collection = NULL;
		gint server_collection_length1 = 0;
		gint _server_collection_size_ = 0;
		gint server_it = 0;
		server_collection = _tmp5_;
		server_collection_length1 = _tmp5__length1;
		for (server_it = 0; server_it < server_collection_length1; server_it = server_it + 1) {
			gchar* _tmp6_;
			gchar* server = NULL;
			_tmp6_ = g_strdup (server_collection[server_it]);
			server = _tmp6_;
			{
				gchar** split = NULL;
				const gchar* _tmp7_;
				const gchar* _tmp8_;
				gchar** _tmp9_;
				gchar** _tmp10_;
				gint split_length1;
				gint _split_size_;
				const gchar* _tmp11_ = NULL;
				gchar** _tmp12_;
				gint _tmp12__length1;
				gchar** _tmp17_;
				gint _tmp17__length1;
				gchar* _tmp18_;
				_tmp7_ = server;
				_tmp8_ = g_strstrip (_tmp7_);
				_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, " ", 2);
				split = _tmp10_;
				split_length1 = _vala_array_length (_tmp9_);
				_split_size_ = split_length1;
				_tmp12_ = split;
				_tmp12__length1 = split_length1;
				if (_tmp12__length1 == 1) {
					gchar** _tmp13_;
					gint _tmp13__length1;
					const gchar* _tmp14_;
					_tmp13_ = split;
					_tmp13__length1 = split_length1;
					_tmp14_ = _tmp13_[0];
					_tmp11_ = _tmp14_;
				} else {
					gchar** _tmp15_;
					gint _tmp15__length1;
					const gchar* _tmp16_;
					_tmp15_ = split;
					_tmp15__length1 = split_length1;
					_tmp16_ = _tmp15_[1];
					_tmp11_ = _tmp16_;
				}
				_tmp17_ = names;
				_tmp17__length1 = names_length1;
				_tmp18_ = g_strdup (_tmp11_);
				_vala_array_add4 (&names, &names_length1, &_names_size_, _tmp18_);
				split = (_vala_array_free (split, split_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (server);
			}
		}
		server_collection = (_vala_array_free (server_collection, server_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	result = names;
	return result;
}

/**
 * Checks to see if the passed uri is valid against registered validators
 */
gboolean
seahorse_servers_is_valid_uri (const gchar* uri)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gchar** parts = NULL;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint parts_length1;
	gint _parts_size_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	if (uri == NULL) {
		_tmp0_ = TRUE;
	} else {
		GHashTable* _tmp1_;
		_tmp1_ = seahorse_servers_server_types;
		_tmp0_ = _tmp1_ == NULL;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp3_ = _tmp2_ = g_strsplit (uri, ":", 2);
	parts = _tmp3_;
	parts_length1 = _vala_array_length (_tmp2_);
	_parts_size_ = parts_length1;
	_tmp4_ = parts;
	_tmp4__length1 = parts_length1;
	if (_tmp4__length1 > 0) {
		SeahorseServersServerInfo* info = NULL;
		GHashTable* _tmp5_;
		gchar** _tmp6_;
		gint _tmp6__length1;
		const gchar* _tmp7_;
		gconstpointer _tmp8_;
		gboolean _tmp9_ = FALSE;
		SeahorseServersServerInfo* _tmp10_;
		_tmp5_ = seahorse_servers_server_types;
		_tmp6_ = parts;
		_tmp6__length1 = parts_length1;
		_tmp7_ = _tmp6_[0];
		_tmp8_ = g_hash_table_lookup (_tmp5_, _tmp7_);
		info = (SeahorseServersServerInfo*) _tmp8_;
		_tmp10_ = info;
		if (_tmp10_ != NULL) {
			SeahorseServersServerInfo* _tmp11_;
			SeahorseValidUriFunc _tmp12_;
			_tmp11_ = info;
			_tmp12_ = (*_tmp11_).validator;
			_tmp9_ = _tmp12_ (uri);
		} else {
			_tmp9_ = FALSE;
		}
		if (_tmp9_) {
			result = TRUE;
			parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
			return result;
		}
	}
	result = FALSE;
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

