/* util.c generated by valac 0.44.7, the Vala compiler
 * generated from util.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2003 Jacob Perkins
 * Copyright (C) 2004-2005 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

void seahorse_util_show_error (GtkWidget* parent,
                               const gchar* heading,
                               const gchar* message);
gchar* seahorse_util_get_display_date_string (guint64 time);
GtkBuilder* seahorse_util_load_built_contents (GtkContainer* frame,
                                               const gchar* name);

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
seahorse_util_show_error (GtkWidget* parent,
                          const gchar* heading,
                          const gchar* message)
{
	GtkWindow* window = NULL;
	GtkMessageDialog* dialog = NULL;
	GtkWindow* _tmp2_;
	GtkMessageDialog* _tmp3_;
	GtkMessageDialog* _tmp6_;
	GtkMessageDialog* _tmp7_;
	window = NULL;
	if (message == NULL) {
		message = "";
	}
	if (parent != NULL) {
		if (!G_TYPE_CHECK_INSTANCE_TYPE (parent, gtk_window_get_type ())) {
			GtkWidget* _tmp0_;
			_tmp0_ = gtk_widget_get_toplevel (parent);
			parent = _tmp0_;
		}
		if (G_TYPE_CHECK_INSTANCE_TYPE (parent, gtk_window_get_type ())) {
			GtkWindow* _tmp1_;
			_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (parent, gtk_window_get_type (), GtkWindow));
			_g_object_unref0 (window);
			window = _tmp1_;
		}
	}
	_tmp2_ = window;
	_tmp3_ = (GtkMessageDialog*) gtk_message_dialog_new (_tmp2_, GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "");
	g_object_ref_sink (_tmp3_);
	dialog = _tmp3_;
	if (heading == NULL) {
		GtkMessageDialog* _tmp4_;
		_tmp4_ = dialog;
		g_object_set ((GObject*) _tmp4_, "text", message, NULL);
	} else {
		GtkMessageDialog* _tmp5_;
		_tmp5_ = dialog;
		g_object_set ((GObject*) _tmp5_, "text", heading, "secondary-text", message, NULL);
	}
	_tmp6_ = dialog;
	gtk_dialog_run ((GtkDialog*) _tmp6_);
	_tmp7_ = dialog;
	gtk_widget_destroy ((GtkWidget*) _tmp7_);
	_g_object_unref0 (dialog);
	_g_object_unref0 (window);
}

gchar*
seahorse_util_get_display_date_string (guint64 time)
{
	gchar* result = NULL;
	GDateTime* created_date = NULL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gchar* _tmp3_;
	if (time == ((guint64) 0)) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("");
		result = _tmp0_;
		return result;
	}
	_tmp1_ = g_date_time_new_from_unix_utc ((gint64) time);
	created_date = _tmp1_;
	_tmp2_ = created_date;
	_tmp3_ = g_date_time_format (_tmp2_, "%x");
	result = _tmp3_;
	_g_date_time_unref0 (created_date);
	return result;
}

GtkBuilder*
seahorse_util_load_built_contents (GtkContainer* frame,
                                   const gchar* name)
{
	GtkBuilder* result = NULL;
	GtkBuilder* builder = NULL;
	GtkBuilder* _tmp0_;
	gchar* path = NULL;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = gtk_builder_new ();
	builder = _tmp0_;
	_tmp1_ = g_strdup_printf ("/org/gnome/Seahorse/seahorse-%s.ui", name);
	path = _tmp1_;
	if (frame != NULL) {
		_tmp2_ = G_TYPE_CHECK_INSTANCE_TYPE (frame, gtk_dialog_get_type ());
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		GtkBox* _tmp3_;
		_tmp3_ = gtk_dialog_get_content_area (G_TYPE_CHECK_INSTANCE_CAST (frame, gtk_dialog_get_type (), GtkDialog));
		frame = (GtkContainer*) _tmp3_;
	}
	{
		GtkBuilder* _tmp4_;
		const gchar* _tmp5_;
		GObject* obj = NULL;
		GtkBuilder* _tmp6_;
		GObject* _tmp7_;
		GObject* _tmp8_;
		GObject* _tmp9_;
		_tmp4_ = builder;
		_tmp5_ = path;
		gtk_builder_add_from_resource (_tmp4_, _tmp5_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch8_g_error;
		}
		_tmp6_ = builder;
		_tmp7_ = gtk_builder_get_object (_tmp6_, name);
		_tmp8_ = _g_object_ref0 (_tmp7_);
		obj = _tmp8_;
		_tmp9_ = obj;
		if (_tmp9_ == NULL) {
			const gchar* _tmp10_;
			_tmp10_ = path;
			g_critical ("util.vala:72: Couldn't find object named %s in %s", name, _tmp10_);
		} else {
			if (frame != NULL) {
				GtkWidget* widget = NULL;
				GObject* _tmp11_;
				GtkWidget* _tmp12_;
				GtkWidget* _tmp13_;
				GtkWidget* _tmp14_;
				_tmp11_ = obj;
				_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_widget_get_type (), GtkWidget));
				widget = _tmp12_;
				_tmp13_ = widget;
				gtk_container_add (frame, _tmp13_);
				_tmp14_ = widget;
				gtk_widget_show (_tmp14_);
				_g_object_unref0 (widget);
			}
		}
		_g_object_unref0 (obj);
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp15_;
		GError* _tmp16_;
		const gchar* _tmp17_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp15_ = path;
		_tmp16_ = err;
		_tmp17_ = _tmp16_->message;
		g_critical ("util.vala:79: Couldn't load %s: %s", _tmp15_, _tmp17_);
		_g_error_free0 (err);
	}
	__finally8:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (path);
		_g_object_unref0 (builder);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = builder;
	_g_free0 (path);
	return result;
}

